Index: /branches/2012/dev_r3385_NOCS04_HAMF/NEMOGCM/NEMO/LIM_SRC_2/limsbc_2.F90
===================================================================
--- /branches/2012/dev_r3385_NOCS04_HAMF/NEMOGCM/NEMO/LIM_SRC_2/limsbc_2.F90	(revision 3516)
+++ /branches/2012/dev_r3385_NOCS04_HAMF/NEMOGCM/NEMO/LIM_SRC_2/limsbc_2.F90	(revision 3517)
@@ -199,5 +199,5 @@
             !
             !                          !------------------------------------------!
-            !                          !      mass flux at the ocean surface      !
+            !                          !  mass and salt flux at the ocean surface !
             !                          !------------------------------------------!
             !
Index: /branches/2012/dev_r3385_NOCS04_HAMF/NEMOGCM/NEMO/LIM_SRC_3/ice.F90
===================================================================
--- /branches/2012/dev_r3385_NOCS04_HAMF/NEMOGCM/NEMO/LIM_SRC_3/ice.F90	(revision 3516)
+++ /branches/2012/dev_r3385_NOCS04_HAMF/NEMOGCM/NEMO/LIM_SRC_3/ice.F90	(revision 3517)
@@ -158,9 +158,10 @@
    !! * Share Module variables
    !!--------------------------------------------------------------------------
-   INTEGER , PUBLIC ::   nstart    !: iteration number of the begining of the run 
-   INTEGER , PUBLIC ::   nlast     !: iteration number of the end of the run 
-   INTEGER , PUBLIC ::   nitrun    !: number of iteration
-   INTEGER , PUBLIC ::   numit     !: iteration number
-   REAL(wp), PUBLIC ::   rdt_ice   !: ice time step
+   INTEGER , PUBLIC ::   nstart      !: iteration number of the begining of the run 
+   INTEGER , PUBLIC ::   nlast       !: iteration number of the end of the run 
+   INTEGER , PUBLIC ::   nitrun      !: number of iteration
+   INTEGER , PUBLIC ::   numit       !: iteration number
+   REAL(wp), PUBLIC ::   rdt_ice     !: ice time step
+   REAL(wp), PUBLIC ::   r1_rdtice   !: = 1. / rdt_ice
 
    !                                          !!** ice-dynamic namelist (namicedyn) **
@@ -201,8 +202,7 @@
    !                                              !!** ice-salinity namelist (namicesal) **
    INTEGER , PUBLIC ::   num_sal     = 1           !: salinity configuration used in the model
-   !                                               ! 1 - s constant in space and time
+   !                                               ! 1 - constant salinity in both space and time
    !                                               ! 2 - prognostic salinity (s(z,t))
    !                                               ! 3 - salinity profile, constant in time
-   !                                               ! 4 - salinity variations affect only ice thermodynamics
    INTEGER , PUBLIC ::   sal_prof    = 1           !: salinity profile or not 
    INTEGER , PUBLIC ::   thcon_i_swi = 1           !: thermal conductivity: =1 Untersteiner (1964) ; =2 Pringle et al (2007)
@@ -278,11 +278,11 @@
    REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:) ::   qfvbq       !: store energy in case of total lateral ablation (?)
    REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:) ::   dmgwi       !: Variation of the mass of snow ice
-   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:) ::   fsalt_res   !: Residual salt flux due to correction of ice thickness
-   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:) ::   fsbri       !: Salt flux due to brine rejection
-   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:) ::   fsalt_rpo   !: Salt flux associated with porous ridged ice formation
-   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:) ::   fheat_rpo   !: Heat flux associated with porous ridged ice formation
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:) ::   fsalt_res   !: Residual salt flux due to correction of ice thickness [???]
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:) ::   fsbri       !: Salt flux due to brine rejection                      [???]
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:) ::   fsalt_rpo   !: Salt flux associated with porous ridged ice formation [???]
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:) ::   fheat_rpo   !: Heat flux associated with porous ridged ice formation [???]
    REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:) ::   fhbri       !: heat flux due to brine rejection
    REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:) ::   fmmec       !: Mass flux due to snow loss during compression
-   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:) ::   fseqv       !: Equivalent salt flux due to ice growth/melt
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:) ::   fseqv       !: salt flux due to ice growth/melt   [units ???]
    REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:) ::   fhmec       !: Heat flux due to snow loss during compression
    REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:) ::   fheat_res   !: Residual heat flux due to correction of ice thickness
Index: /branches/2012/dev_r3385_NOCS04_HAMF/NEMOGCM/NEMO/LIM_SRC_3/iceini.F90
===================================================================
--- /branches/2012/dev_r3385_NOCS04_HAMF/NEMOGCM/NEMO/LIM_SRC_3/iceini.F90	(revision 3516)
+++ /branches/2012/dev_r3385_NOCS04_HAMF/NEMOGCM/NEMO/LIM_SRC_3/iceini.F90	(revision 3517)
@@ -79,5 +79,6 @@
       CALL lim_thd_sal_init            ! set ice salinity parameters
       !
-      rdt_ice = nn_fsbc * rdttra(1)    ! sea-ice timestep
+      rdt_ice   = nn_fsbc * rdttra(1)  ! sea-ice timestep
+      r1_rdtice = 1._wp / rdt_ice      ! sea-ice timestep inverse
       !
       CALL lim_msh                     ! ice mesh initialization
Index: /branches/2012/dev_r3385_NOCS04_HAMF/NEMOGCM/NEMO/LIM_SRC_3/limadv.F90
===================================================================
--- /branches/2012/dev_r3385_NOCS04_HAMF/NEMOGCM/NEMO/LIM_SRC_3/limadv.F90	(revision 3516)
+++ /branches/2012/dev_r3385_NOCS04_HAMF/NEMOGCM/NEMO/LIM_SRC_3/limadv.F90	(revision 3517)
@@ -88,5 +88,5 @@
             zs2new  = MIN(  2.0 * zslpmax - 0.3334 * ABS( zs1new ),      &
                &            MAX( ABS( zs1new ) - zslpmax, psxx(ji,jj) )  )
-            zin0    = ( 1.0 - MAX( rzero, sign ( rone, -zslpmax) ) ) * tms(ji,jj)   ! Case of empty boxes & Apply mask
+            zin0    = ( 1.0 - MAX( rzero, SIGN( rone, -zslpmax) ) ) * tms(ji,jj)   ! Case of empty boxes & Apply mask
 
             ps0 (ji,jj) = zslpmax  
@@ -273,5 +273,5 @@
             zs2new  = MIN(  ( 2.0 * zslpmax - 0.3334 * ABS( zs1new ) ),   &
                &             MAX( ABS( zs1new )-zslpmax, psyy(ji,jj) )  )
-            zin0    = ( 1.0 - MAX( rzero, sign ( rone, -zslpmax) ) ) * tms(ji,jj)   ! Case of empty boxes & Apply mask
+            zin0    = ( 1.0 - MAX( rzero, SIGN( rone, -zslpmax) ) ) * tms(ji,jj)   ! Case of empty boxes & Apply mask
             !
             ps0 (ji,jj) = zslpmax  
Index: /branches/2012/dev_r3385_NOCS04_HAMF/NEMOGCM/NEMO/LIM_SRC_3/limdia.F90
===================================================================
--- /branches/2012/dev_r3385_NOCS04_HAMF/NEMOGCM/NEMO/LIM_SRC_3/limdia.F90	(revision 3516)
+++ /branches/2012/dev_r3385_NOCS04_HAMF/NEMOGCM/NEMO/LIM_SRC_3/limdia.F90	(revision 3517)
@@ -180,5 +180,5 @@
                vinfor(43) = vinfor(43) + diag_dyn_gr(ji,jj)*aire(ji,jj) * 1.e-12_wp 
                vinfor(45) = vinfor(45) + dv_dt_thd(ji,jj,5)*aire(ji,jj) * 1.e-12_wp
-               vinfor(47) = vinfor(47) + v_newice(ji,jj) *aire(ji,jj) * 1.e-12_wp / rdt_ice ! volume acc in OW
+               vinfor(47) = vinfor(47) + v_newice(ji,jj) *aire(ji,jj) * 1.e-12_wp * r1_rdtice   ! volume acc in OW
             ENDIF
          END DO
@@ -240,8 +240,6 @@
       vinfor(84) = 0.0
       DO ji = 134, 138
-         vinfor(83) = vinfor(83) - v_ice(ji,jj) * & 
-            e1t(ji,jj)*at_i(ji,jj)*rdt_ice * 1.e-12_wp
-         vinfor(84) = vinfor(84) - v_ice(ji,jj) * & 
-            e1t(ji,jj)*vt_i(ji,jj)*rdt_ice * 1.e-12_wp
+         vinfor(83) = vinfor(83) - v_ice(ji,jj) * e1t(ji,jj)*at_i(ji,jj)*rdt_ice * 1.e-12_wp
+         vinfor(84) = vinfor(84) - v_ice(ji,jj) * e1t(ji,jj)*vt_i(ji,jj)*rdt_ice * 1.e-12_wp
       END DO
 
@@ -331,5 +329,5 @@
                vinfor(44) = vinfor(44) + diag_dyn_gr(ji,jj)*aire(ji,jj) * 1.e-12_wp 
                vinfor(46) = vinfor(46) + dv_dt_thd(ji,jj,5)*aire(ji,jj) * 1.e-12_wp
-               vinfor(48) = vinfor(48) + v_newice(ji,jj) *aire(ji,jj) * 1.e-12_wp / rdt_ice ! volume acc in OW
+               vinfor(48) = vinfor(48) + v_newice(ji,jj) *aire(ji,jj) * 1.e-12_wp * r1_rdtice   ! volume acc in OW
             ENDIF
          END DO
Index: /branches/2012/dev_r3385_NOCS04_HAMF/NEMOGCM/NEMO/LIM_SRC_3/limitd_me.F90
===================================================================
--- /branches/2012/dev_r3385_NOCS04_HAMF/NEMOGCM/NEMO/LIM_SRC_3/limitd_me.F90	(revision 3516)
+++ /branches/2012/dev_r3385_NOCS04_HAMF/NEMOGCM/NEMO/LIM_SRC_3/limitd_me.F90	(revision 3517)
@@ -38,7 +38,7 @@
    PUBLIC   lim_itd_me_alloc        ! called by iceini.F90
 
-   REAL(wp)  ::   epsi11 = 1.e-11_wp   ! constant values
-   REAL(wp)  ::   epsi10 = 1.e-10_wp   ! constant values
-   REAL(wp)  ::   epsi06 = 1.e-06_wp   ! constant values
+   REAL(wp) ::   epsi11 = 1.e-11_wp   ! constant values
+   REAL(wp) ::   epsi10 = 1.e-10_wp   ! constant values
+   REAL(wp) ::   epsi06 = 1.e-06_wp   ! constant values
 
    !-----------------------------------------------------------------------
@@ -47,8 +47,8 @@
    REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:)   ::   asum     ! sum of total ice and open water area
    REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:)   ::   aksum    ! ratio of area removed to area ridged
-
+   !
    REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   athorn   ! participation function; fraction of ridging/
    !                                                           !  closing associated w/ category n
-
+   !
    REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   hrmin    ! minimum ridge thickness
    REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   hrmax    ! maximum ridge thickness
@@ -70,4 +70,5 @@
    REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:) ::   dvirdgdt   ! rate of ice volume ridged (m/s)
    REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:) ::   opening    ! rate of opening due to divergence/shear (1/s)
+   !
    !!----------------------------------------------------------------------
    !! NEMO/LIM3 3.3 , UCL - NEMO Consortium (2010)
@@ -126,7 +127,7 @@
       INTEGER ::   ji, jj, jk, jl   ! dummy loop index
       INTEGER ::   niter, nitermax = 20   ! local integer 
-      LOGICAL  ::   asum_error              ! flag for asum .ne. 1
-      INTEGER  ::   iterate_ridging         ! if true, repeat the ridging
-      REAL(wp) ::   w1, tmpfac, dti         ! local scalar
+      LOGICAL  ::   asum_error            ! flag for asum .ne. 1
+      INTEGER  ::   iterate_ridging       ! if true, repeat the ridging
+      REAL(wp) ::   w1, tmpfac            ! local scalar
       CHARACTER (len = 15) ::   fieldid
       REAL(wp), POINTER, DIMENSION(:,:) ::   closing_net     ! net rate at which area is removed    (1/s)
@@ -152,12 +153,12 @@
       ! 1) Thickness categories boundaries, ice / o.w. concentrations, init_ons
       !-----------------------------------------------------------------------------!
-      ! Set hi_max(ncat) to a big value to ensure that all ridged ice 
-      ! is thinner than hi_max(ncat).
+      ! Set hi_max(ncat) to a big value to ensure that all ridged ice is thinner than hi_max(ncat).
 
       hi_max(jpl) = 999.99
 
-      Cp = 0.5 * grav * (rau0-rhoic) * rhoic / rau0      ! proport const for PE
-      CALL lim_itd_me_ridgeprep ! prepare ridging
-
+      Cp = 0.5 * grav * (rau0-rhoic) * rhoic / rau0                ! proport const for PE
+      !
+      CALL lim_itd_me_ridgeprep                                    ! prepare ridging
+      !
       IF( con_i)   CALL lim_column_sum( jpl, v_i, vt_i_init )      ! conservation check
 
@@ -166,8 +167,8 @@
             msnow_mlt(ji,jj) = 0._wp
             esnow_mlt(ji,jj) = 0._wp
-            dardg1dt (ji,jj)  = 0._wp
-            dardg2dt (ji,jj)  = 0._wp
-            dvirdgdt (ji,jj)  = 0._wp
-            opening  (ji,jj)  = 0._wp
+            dardg1dt (ji,jj) = 0._wp
+            dardg2dt (ji,jj) = 0._wp
+            dvirdgdt (ji,jj) = 0._wp
+            opening  (ji,jj) = 0._wp
 
             !-----------------------------------------------------------------------------!
@@ -201,5 +202,5 @@
             ! to give asum = 1.0 after ridging.
 
-            divu_adv(ji,jj) = ( 1._wp - asum(ji,jj) ) / rdt_ice  ! asum found in ridgeprep
+            divu_adv(ji,jj) = ( 1._wp - asum(ji,jj) ) * r1_rdtice  ! asum found in ridgeprep
 
             IF( divu_adv(ji,jj) < 0._wp )   closing_net(ji,jj) = MAX( closing_net(ji,jj), -divu_adv(ji,jj) )
@@ -207,6 +208,5 @@
             ! 2.3 opning
             !------------
-            ! Compute the (non-negative) opening rate that will give 
-            ! asum = 1.0 after ridging.
+            ! Compute the (non-negative) opening rate that will give asum = 1.0 after ridging.
             opning(ji,jj) = closing_net(ji,jj) + divu_adv(ji,jj)
          END DO
@@ -257,5 +257,5 @@
                   IF ( a_i(ji,jj,jl) > epsi11 .AND. athorn(ji,jj,jl) > 0._wp )THEN
                      w1 = athorn(ji,jj,jl) * closing_gross(ji,jj) * rdt_ice
-                     IF ( w1 > a_i(ji,jj,jl) ) THEN
+                     IF ( w1  >  a_i(ji,jj,jl) ) THEN
                         tmpfac = a_i(ji,jj,jl) / w1
                         closing_gross(ji,jj) = closing_gross(ji,jj) * tmpfac
@@ -291,5 +291,5 @@
                ELSE
                   iterate_ridging    = 1
-                  divu_adv   (ji,jj) = (1._wp - asum(ji,jj)) / rdt_ice
+                  divu_adv   (ji,jj) = (1._wp - asum(ji,jj)) * r1_rdtice
                   closing_net(ji,jj) = MAX( 0._wp, -divu_adv(ji,jj) )
                   opning     (ji,jj) = MAX( 0._wp,  divu_adv(ji,jj) )
@@ -308,5 +308,5 @@
 
          IF( iterate_ridging == 1 ) THEN
-            IF( niter .GT. nitermax ) THEN
+            IF( niter  >  nitermax ) THEN
                WRITE(numout,*) ' ALERTE : non-converging ridging scheme '
                WRITE(numout,*) ' niter, iterate_ridging ', niter, iterate_ridging
@@ -323,6 +323,4 @@
       ! Update fresh water and heat fluxes due to snow melt.
 
-      dti = 1._wp / rdt_ice
-
       asum_error = .false. 
 
@@ -330,16 +328,16 @@
          DO ji = 1, jpi
 
-            IF (ABS(asum(ji,jj) - 1.0) .GT. epsi11) asum_error = .true.
-
-            dardg1dt(ji,jj) = dardg1dt(ji,jj) * dti
-            dardg2dt(ji,jj) = dardg2dt(ji,jj) * dti
-            dvirdgdt(ji,jj) = dvirdgdt(ji,jj) * dti
-            opening (ji,jj) = opening (ji,jj) * dti
+            IF( ABS( asum(ji,jj) - 1.0 ) > epsi11 )   asum_error = .true.
+
+            dardg1dt(ji,jj) = dardg1dt(ji,jj) * r1_rdtice
+            dardg2dt(ji,jj) = dardg2dt(ji,jj) * r1_rdtice
+            dvirdgdt(ji,jj) = dvirdgdt(ji,jj) * r1_rdtice
+            opening (ji,jj) = opening (ji,jj) * r1_rdtice
 
             !-----------------------------------------------------------------------------!
             ! 5) Heat, salt and freshwater fluxes
             !-----------------------------------------------------------------------------!
-            fmmec(ji,jj) = fmmec(ji,jj) + msnow_mlt(ji,jj) * dti     ! fresh water source for ocean
-            fhmec(ji,jj) = fhmec(ji,jj) + esnow_mlt(ji,jj) * dti     ! heat sink for ocean
+            fmmec(ji,jj) = fmmec(ji,jj) + msnow_mlt(ji,jj) * r1_rdtice     ! fresh water source for ocean
+            fhmec(ji,jj) = fhmec(ji,jj) + esnow_mlt(ji,jj) * r1_rdtice     ! heat sink for ocean
 
          END DO
@@ -349,5 +347,5 @@
       DO jj = 1, jpj
          DO ji = 1, jpi
-            IF (ABS(asum(ji,jj) - 1.0) .GT. epsi11) THEN ! there is a bug
+            IF( ABS( asum(ji,jj) - 1._wp )  >  epsi11 ) THEN   ! there is a bug
                WRITE(numout,*) ' '
                WRITE(numout,*) ' ALERTE : Ridging error: total area = ', asum(ji,jj)
@@ -391,5 +389,5 @@
       d_oa_i_trp (:,:,:)   = oa_i (:,:,:)   - old_oa_i (:,:,:)
       d_smv_i_trp(:,:,:)   = 0._wp
-      IF(  num_sal == 2  .OR.  num_sal == 4  )   d_smv_i_trp(:,:,:)  = smv_i(:,:,:) - old_smv_i(:,:,:)
+      IF(  num_sal == 2  )   d_smv_i_trp(:,:,:)  = smv_i(:,:,:) - old_smv_i(:,:,:)
 
       IF(ln_ctl) THEN     ! Control print
@@ -430,13 +428,13 @@
 
       ! update of fields will be made later in lim update
-      u_ice(:,:)    = old_u_ice(:,:)
-      v_ice(:,:)    = old_v_ice(:,:)
-      a_i(:,:,:)    = old_a_i(:,:,:)
-      v_s(:,:,:)    = old_v_s(:,:,:)
-      v_i(:,:,:)    = old_v_i(:,:,:)
-      e_s(:,:,:,:)  = old_e_s(:,:,:,:)
-      e_i(:,:,:,:)  = old_e_i(:,:,:,:)
-      oa_i(:,:,:)   = old_oa_i(:,:,:)
-      IF(  num_sal == 2  .OR.  num_sal == 4  )   smv_i(:,:,:)  = old_smv_i(:,:,:)
+      u_ice(:,:)   = old_u_ice(:,:)
+      v_ice(:,:)   = old_v_ice(:,:)
+      a_i(:,:,:)   = old_a_i(:,:,:)
+      v_s(:,:,:)   = old_v_s(:,:,:)
+      v_i(:,:,:)   = old_v_i(:,:,:)
+      e_s(:,:,:,:) = old_e_s(:,:,:,:)
+      e_i(:,:,:,:) = old_e_i(:,:,:,:)
+      oa_i(:,:,:)  = old_oa_i(:,:,:)
+      IF(  num_sal == 2  )   smv_i(:,:,:) = old_smv_i(:,:,:)
 
       !----------------------------------------------------!
@@ -465,23 +463,23 @@
          DO jj = 1, jpj
             DO ji = 1, jpi
-               IF ( ( old_v_i(ji,jj,jl) < epsi06 ) .AND. &
-                  ( d_v_i_trp(ji,jj,jl) > epsi06 ) ) THEN
-                  old_v_i(ji,jj,jl)     = d_v_i_trp(ji,jj,jl)
-                  d_v_i_trp(ji,jj,jl)   = 0._wp
-                  old_a_i(ji,jj,jl)     = d_a_i_trp(ji,jj,jl)
-                  d_a_i_trp(ji,jj,jl)   = 0._wp
-                  old_v_s(ji,jj,jl)     = d_v_s_trp(ji,jj,jl)
-                  d_v_s_trp(ji,jj,jl)   = 0._wp
-                  old_e_s(ji,jj,1,jl)   = d_e_s_trp(ji,jj,1,jl)
-                  d_e_s_trp(ji,jj,1,jl) = 0._wp
-                  old_oa_i(ji,jj,jl)    = d_oa_i_trp(ji,jj,jl)
-                  d_oa_i_trp(ji,jj,jl)  = 0._wp
-                  IF(  num_sal == 2  .OR.  num_sal == 4  )   old_smv_i(ji,jj,jl)   = d_smv_i_trp(ji,jj,jl)
-                  d_smv_i_trp(ji,jj,jl) = 0._wp
+               IF(  old_v_i  (ji,jj,jl) < epsi06  .AND. &
+                    d_v_i_trp(ji,jj,jl) > epsi06    ) THEN
+                  old_v_i   (ji,jj,jl)   = d_v_i_trp(ji,jj,jl)
+                  d_v_i_trp (ji,jj,jl)   = 0._wp
+                  old_a_i   (ji,jj,jl)   = d_a_i_trp(ji,jj,jl)
+                  d_a_i_trp (ji,jj,jl)   = 0._wp
+                  old_v_s   (ji,jj,jl)   = d_v_s_trp(ji,jj,jl)
+                  d_v_s_trp (ji,jj,jl)   = 0._wp
+                  old_e_s   (ji,jj,1,jl) = d_e_s_trp(ji,jj,1,jl)
+                  d_e_s_trp (ji,jj,1,jl) = 0._wp
+                  old_oa_i  (ji,jj,jl)   = d_oa_i_trp(ji,jj,jl)
+                  d_oa_i_trp(ji,jj,jl)   = 0._wp
+                  IF(  num_sal == 2  )   old_smv_i(ji,jj,jl) = d_smv_i_trp(ji,jj,jl)
+                  d_smv_i_trp(ji,jj,jl)  = 0._wp
                ENDIF
             END DO
          END DO
       END DO
-
+      !
       CALL wrk_dealloc( jpi, jpj, closing_net, divu_adv, opning, closing_gross, msnow_mlt, esnow_mlt, vt_i_init, vt_i_final )
       !
@@ -612,13 +610,13 @@
                   ! present
                   zworka(ji,jj) = 4.0 * strength(ji,jj)              &
-                     + strength(ji-1,jj) * tms(ji-1,jj) &  
-                     + strength(ji+1,jj) * tms(ji+1,jj) &  
-                     + strength(ji,jj-1) * tms(ji,jj-1) &  
-                     + strength(ji,jj+1) * tms(ji,jj+1)    
+                     &          + strength(ji-1,jj) * tms(ji-1,jj) &  
+                     &          + strength(ji+1,jj) * tms(ji+1,jj) &  
+                     &          + strength(ji,jj-1) * tms(ji,jj-1) &  
+                     &          + strength(ji,jj+1) * tms(ji,jj+1)    
 
                   zw1 = 4.0 + tms(ji-1,jj) + tms(ji+1,jj) + tms(ji,jj-1) + tms(ji,jj+1)
                   zworka(ji,jj) = zworka(ji,jj) / zw1
                ELSE
-                  zworka(ji,jj) = 0.0
+                  zworka(ji,jj) = 0._wp
                ENDIF
             END DO
@@ -1048,6 +1046,6 @@
          DO jj = 1, jpj
             DO ji = 1, jpi
-               IF (aicen_init(ji,jj,jl1) .GT. epsi11 .AND. athorn(ji,jj,jl1) .GT. 0.0       &
-                  .AND. closing_gross(ji,jj) > 0.0) THEN
+               IF( aicen_init(ji,jj,jl1)  >  epsi11  .AND.  athorn(ji,jj,jl1)  >  0._wp       &
+                  .AND. closing_gross(ji,jj) > 0._wp ) THEN
                   icells = icells + 1
                   indxi(icells) = ji
@@ -1130,5 +1128,5 @@
             ! Salinity
             !-------------
-            smsw(ji,jj)  = sss_m(ji,jj) * vsw(ji,jj) * rhoic / rau0       ! salt content of water frozen in voids
+            smsw(ji,jj)  = sss_m(ji,jj) * vsw(ji,jj) * rhoic / rau0       ! salt content of seawater frozen in voids
 
             zsrdg2       = srdg1(ji,jj) + smsw(ji,jj)                     ! salt content of new ridge
@@ -1137,6 +1135,8 @@
             
             !                                                             ! excess of salt is flushed into the ocean
-            fsalt_rpo(ji,jj) = fsalt_rpo(ji,jj) + ( zsrdg2 - srdg2(ji,jj) ) * rhoic / rdt_ice
-
+            fsalt_rpo(ji,jj) = fsalt_rpo(ji,jj) + ( zsrdg2 - srdg2(ji,jj) ) * rhoic * r1_rdtice
+
+            rdm_ice(ji,jj) = rdm_ice(ji,jj) + vsw(ji,jj) * rhoic / rau0   ! increase in ice volume du to seawater frozen in voids
+            
             !------------------------------------            
             ! 3.6 Increment ridging diagnostics
@@ -1148,6 +1148,6 @@
             dardg1dt   (ji,jj) = dardg1dt(ji,jj) + ardg1(ji,jj) + arft1(ji,jj)
             dardg2dt   (ji,jj) = dardg2dt(ji,jj) + ardg2(ji,jj) + arft2(ji,jj)
-            diag_dyn_gr(ji,jj) = diag_dyn_gr(ji,jj) + ( vrdg2(ji,jj) + virft(ji,jj) ) / rdt_ice
-            opening    (ji,jj) = opening (ji,jj) + opning(ji,jj)*rdt_ice
+            diag_dyn_gr(ji,jj) = diag_dyn_gr(ji,jj) + ( vrdg2(ji,jj) + virft(ji,jj) ) * r1_rdtice
+            opening    (ji,jj) = opening (ji,jj) + opning(ji,jj) * rdt_ice
 
             IF( con_i )   vice_init(ji,jj) = vice_init(ji,jj) + vrdg2(ji,jj) - vrdg1(ji,jj)
@@ -1156,5 +1156,4 @@
             ! 3.7 Put the snow somewhere in the ocean
             !------------------------------------------            
-
             !  Place part of the snow lost by ridging into the ocean. 
             !  Note that esnow_mlt < 0; the ocean must cool to melt snow.
@@ -1179,7 +1178,6 @@
             !           ij looping 1-icells
 
-            dhr(ji,jj)  = hrmax(ji,jj,jl1) - hrmin(ji,jj,jl1)
+            dhr (ji,jj) = hrmax(ji,jj,jl1) - hrmin(ji,jj,jl1)
             dhr2(ji,jj) = hrmax(ji,jj,jl1) * hrmax(ji,jj,jl1) - hrmin(ji,jj,jl1) * hrmin(ji,jj,jl1)
-
 
          END DO                 ! ij
@@ -1211,5 +1209,5 @@
 
                ! heat flux
-               fheat_rpo(ji,jj) = fheat_rpo(ji,jj) + ( ersw(ji,jj,jk) - zdummy0 ) / rdt_ice
+               fheat_rpo(ji,jj) = fheat_rpo(ji,jj) + ( ersw(ji,jj,jk) - zdummy0 ) * r1_rdtice
 
                ! Correct dimensions to avoid big values
@@ -1275,23 +1273,23 @@
                ! Transfer area, volume, and energy accordingly.
 
-               IF (hrmin(ji,jj,jl1) .GE. hi_max(jl2) .OR.        &
-                  hrmax(ji,jj,jl1) .LE. hi_max(jl2-1)) THEN
-                  hL = 0.0
-                  hR = 0.0
+               IF( hrmin(ji,jj,jl1) >= hi_max(jl2)  .OR.        &
+                   hrmax(ji,jj,jl1) <= hi_max(jl2-1) ) THEN
+                  hL = 0._wp
+                  hR = 0._wp
                ELSE
-                  hL = MAX (hrmin(ji,jj,jl1), hi_max(jl2-1))
-                  hR = MIN (hrmax(ji,jj,jl1), hi_max(jl2))
+                  hL = MAX( hrmin(ji,jj,jl1), hi_max(jl2-1) )
+                  hR = MIN( hrmax(ji,jj,jl1), hi_max(jl2)   )
                ENDIF
 
                ! fraction of ridged ice area and volume going to n2
-               farea = (hR-hL) / dhr(ji,jj) 
-               fvol(ji,jj) = (hR*hR - hL*hL) / dhr2(ji,jj)
-
-               a_i  (ji,jj,jl2)   = a_i  (ji,jj,jl2)   + ardg2 (ji,jj) * farea
-               v_i  (ji,jj,jl2)   = v_i  (ji,jj,jl2)   + vrdg2 (ji,jj) * fvol(ji,jj)
-               v_s  (ji,jj,jl2)   = v_s  (ji,jj,jl2)   + vsrdg (ji,jj) * fvol(ji,jj) * fsnowrdg
+               farea = ( hR - hL ) / dhr(ji,jj) 
+               fvol(ji,jj) = ( hR*hR - hL*hL ) / dhr2(ji,jj)
+
+               a_i  (ji,jj  ,jl2) = a_i  (ji,jj  ,jl2) + ardg2 (ji,jj) * farea
+               v_i  (ji,jj  ,jl2) = v_i  (ji,jj  ,jl2) + vrdg2 (ji,jj) * fvol(ji,jj)
+               v_s  (ji,jj  ,jl2) = v_s  (ji,jj  ,jl2) + vsrdg (ji,jj) * fvol(ji,jj) * fsnowrdg
                e_s  (ji,jj,1,jl2) = e_s  (ji,jj,1,jl2) + esrdg (ji,jj) * fvol(ji,jj) * fsnowrdg
-               smv_i(ji,jj,jl2)   = smv_i(ji,jj,jl2)   + srdg2 (ji,jj) * fvol(ji,jj)
-               oa_i (ji,jj,jl2)   = oa_i (ji,jj,jl2)   + oirdg2(ji,jj) * farea
+               smv_i(ji,jj  ,jl2) = smv_i(ji,jj  ,jl2) + srdg2 (ji,jj) * fvol(ji,jj)
+               oa_i (ji,jj  ,jl2) = oa_i (ji,jj  ,jl2) + oirdg2(ji,jj) * farea
 
             END DO ! ij
@@ -1317,15 +1315,15 @@
                ! Compute the fraction of rafted ice area and volume going to 
                ! thickness category jl2, transfer area, volume, and energy accordingly.
-
-               IF (hraft(ji,jj,jl1) .LE. hi_max(jl2) .AND.        &
-                  hraft(ji,jj,jl1) .GT. hi_max(jl2-1)) THEN
-                  a_i(ji,jj,jl2) = a_i(ji,jj,jl2) + arft2(ji,jj)
-                  v_i(ji,jj,jl2) = v_i(ji,jj,jl2) + virft(ji,jj)
-                  v_s(ji,jj,jl2) = v_s(ji,jj,jl2) + vsrft(ji,jj)*fsnowrft
-                  e_s(ji,jj,1,jl2) = e_s(ji,jj,1,jl2) + esrft(ji,jj)*fsnowrft
-                  smv_i(ji,jj,jl2) = smv_i(ji,jj,jl2) + smrft(ji,jj)    
-                  oa_i(ji,jj,jl2)  = oa_i(ji,jj,jl2)  + oirft2(ji,jj)    
+               !
+               IF( hraft(ji,jj,jl1) <= hi_max(jl2)  .AND.        &
+                   hraft(ji,jj,jl1) >  hi_max(jl2-1) ) THEN
+                  a_i  (ji,jj  ,jl2) = a_i  (ji,jj  ,jl2) + arft2 (ji,jj)
+                  v_i  (ji,jj  ,jl2) = v_i  (ji,jj  ,jl2) + virft (ji,jj)
+                  v_s  (ji,jj  ,jl2) = v_s  (ji,jj  ,jl2) + vsrft (ji,jj) * fsnowrft
+                  e_s  (ji,jj,1,jl2) = e_s  (ji,jj,1,jl2) + esrft (ji,jj) * fsnowrft
+                  smv_i(ji,jj  ,jl2) = smv_i(ji,jj  ,jl2) + smrft (ji,jj)    
+                  oa_i (ji,jj  ,jl2) = oa_i (ji,jj  ,jl2) + oirft2(ji,jj)    
                ENDIF ! hraft
-
+               !
             END DO ! ij
 
@@ -1336,6 +1334,6 @@
                   ji = indxi(ij)
                   jj = indxj(ij)
-                  IF (hraft(ji,jj,jl1) .LE. hi_max(jl2) .AND.        &
-                     hraft(ji,jj,jl1) .GT. hi_max(jl2-1)) THEN
+                  IF(  hraft(ji,jj,jl1)  <=  hi_max(jl2)   .AND.        &
+                       hraft(ji,jj,jl1)  >   hi_max(jl2-1)  ) THEN
                      e_i(ji,jj,jk,jl2) = e_i(ji,jj,jk,jl2) + eirft(ji,jj,jk)
                   ENDIF
@@ -1504,5 +1502,5 @@
             DO jj = 1 , jpj
                DO ji = 1 , jpi
-!!gm                  xtmp = e_i(ji,jj,jk,jl) / area(ji,jj) / rdt_ice
+!!gm                  xtmp = e_i(ji,jj,jk,jl) / area(ji,jj) * r1_rdtice
 !!gm                  xtmp = xtmp * unit_fac
                   ! fheat_res(ji,jj) = fheat_res(ji,jj) - xtmp
@@ -1524,8 +1522,8 @@
                ! fluxes are positive to the ocean
                ! here the flux has to be negative for the ocean
-!!gm               xtmp = ( rhosn*cpic*( rtt-t_s(ji,jj,1,jl) ) + rhosn*lfus ) / rdt_ice
+!!gm               xtmp = ( rhosn*cpic*( rtt-t_s(ji,jj,1,jl) ) + rhosn*lfus ) * r1_rdtice
                !           fheat_res(ji,jj) = fheat_res(ji,jj) - xtmp
 
-!!gm               xtmp = ( rhosn*cpic*( rtt-t_s(ji,jj,1,jl) ) + rhosn*lfus ) / rdt_ice !RB   ???????
+!!gm               xtmp = ( rhosn*cpic*( rtt-t_s(ji,jj,1,jl) ) + rhosn*lfus ) * r1_rdtice !RB   ???????
 
                t_s(ji,jj,1,jl) = rtt * zmask(ji,jj) + t_s(ji,jj,1,jl) * ( 1 - zmask(ji,jj) )
@@ -1540,8 +1538,8 @@
 
                !           fsalt_res(ji,jj)  = fsalt_res(ji,jj) + ( sss_m(ji,jj)                  ) * & 
-               !                               rhosn * v_s(ji,jj,jl) / rdt_ice
+               !                               rhosn * v_s(ji,jj,jl) * r1_rdtice
 
                !           fsalt_res(ji,jj)  = fsalt_res(ji,jj) + ( sss_m(ji,jj) - sm_i(ji,jj,jl) ) * & 
-               !                               rhoic * v_i(ji,jj,jl) / rdt_ice
+               !                               rhoic * v_i(ji,jj,jl) * r1_rdtice
 
                !           sfx (i,j)      = sfx (i,j)      + xtmp
Index: /branches/2012/dev_r3385_NOCS04_HAMF/NEMOGCM/NEMO/LIM_SRC_3/limitd_th.F90
===================================================================
--- /branches/2012/dev_r3385_NOCS04_HAMF/NEMOGCM/NEMO/LIM_SRC_3/limitd_th.F90	(revision 3516)
+++ /branches/2012/dev_r3385_NOCS04_HAMF/NEMOGCM/NEMO/LIM_SRC_3/limitd_th.F90	(revision 3517)
@@ -101,12 +101,12 @@
 
       !- Trend terms
-      d_a_i_thd (:,:,:)  = a_i(:,:,:)   - old_a_i(:,:,:) 
-      d_v_s_thd (:,:,:)  = v_s(:,:,:)   - old_v_s(:,:,:)
-      d_v_i_thd (:,:,:)  = v_i(:,:,:)   - old_v_i(:,:,:)  
+      d_a_i_thd(:,:,:)   = a_i(:,:,:)   - old_a_i(:,:,:) 
+      d_v_s_thd(:,:,:)   = v_s(:,:,:)   - old_v_s(:,:,:)
+      d_v_i_thd(:,:,:)   = v_i(:,:,:)   - old_v_i(:,:,:)  
       d_e_s_thd(:,:,:,:) = e_s(:,:,:,:) - old_e_s(:,:,:,:) 
       d_e_i_thd(:,:,:,:) = e_i(:,:,:,:) - old_e_i(:,:,:,:)
 
       d_smv_i_thd(:,:,:) = 0._wp
-      IF( num_sal == 2 .OR. num_sal == 4 )   d_smv_i_thd(:,:,:) = smv_i(:,:,:) - old_smv_i(:,:,:)
+      IF( num_sal == 2  )   d_smv_i_thd(:,:,:) = smv_i(:,:,:) - old_smv_i(:,:,:)
 
       IF(ln_ctl) THEN   ! Control print
@@ -143,11 +143,11 @@
 
       !- Recover Old values
-      a_i(:,:,:)   = old_a_i (:,:,:)
-      v_s(:,:,:)   = old_v_s (:,:,:)
-      v_i(:,:,:)   = old_v_i (:,:,:)
-      e_s(:,:,:,:) = old_e_s (:,:,:,:)
-      e_i(:,:,:,:) = old_e_i (:,:,:,:)
-      !
-      IF( num_sal == 2 .OR. num_sal == 4 )   smv_i(:,:,:)       = old_smv_i (:,:,:)
+      a_i(:,:,:)   = old_a_i(:,:,:)
+      v_s(:,:,:)   = old_v_s(:,:,:)
+      v_i(:,:,:)   = old_v_i(:,:,:)
+      e_s(:,:,:,:) = old_e_s(:,:,:,:)
+      e_i(:,:,:,:) = old_e_i(:,:,:,:)
+      !
+      IF( num_sal == 2 )   smv_i(:,:,:) = old_smv_i(:,:,:)
       !
    END SUBROUTINE lim_itd_th
Index: /branches/2012/dev_r3385_NOCS04_HAMF/NEMOGCM/NEMO/LIM_SRC_3/limrst.F90
===================================================================
--- /branches/2012/dev_r3385_NOCS04_HAMF/NEMOGCM/NEMO/LIM_SRC_3/limrst.F90	(revision 3516)
+++ /branches/2012/dev_r3385_NOCS04_HAMF/NEMOGCM/NEMO/LIM_SRC_3/limrst.F90	(revision 3517)
@@ -402,7 +402,7 @@
                      zsmax = 4.5_wp
                      zsmin = 3.5_wp
-                     IF( sm_i(ji,jj,jl) .LT. zsmin ) THEN
+                     IF(     sm_i(ji,jj,jl) < zsmin ) THEN
                         zalpha = 1._wp
-                     ELSEIF( sm_i(ji,jj,jl) .LT.zsmax ) THEN
+                     ELSEIF( sm_i(ji,jj,jl) < zsmax ) THEN
                         zalpha = sm_i(ji,jj,jl) / ( zsmin - zsmax ) + zsmax / ( zsmax - zsmin )
                      ELSE
